Panda3D

Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
Event Class Reference

A named event, possibly with parameters. More...

`#include "event.h"`

Inheritance diagram for Event:

## Public Member Functions
| Event (const Event &copy)
| Event (const std::string &event_name, EventReceiver *receiver=nullptr)
void | add_parameter (const EventParameter &obj)
void | clear_name ()
| Resets the Event's name to empty. More...
void | clear_receiver ()
virtual TypeHandle | force_init_type ()
const std::string & | get_name () const
int | get_num_parameters () const
EventParameter | get_parameter (int n) const
EventReceiver * | get_receiver () const
virtual TypeHandle | get_type () const
bool | has_name () const
| Returns true if the Event has a nonempty name set, false if the name is empty. More...
bool | has_receiver () const
void | operator= (const Event &copy)
void | output (std::ostream &out) const
void | set_name (const std::string &name)
void | set_receiver (EventReceiver *receiver)
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type. More...
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly. More...
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type. More...
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object. More...
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise. More...
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack. More...
void | ref () const
| Explicitly increments the reference count. More...
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero. More...
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus. More...
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus. More...
virtual bool | unref () const
| Explicitly decrements the reference count. More...
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one. More...
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object. More...
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object. More...

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96. More...
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
| clear_receiver
| get_name
| get_num_parameters
| get_parameter
| get_receiver
| has_receiver
| set_name
| set_receiver
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count. More...

## Detailed Description

A named event, possibly with parameters.

Anyone in any thread may throw an event at any time; there will be one process responsible for reading and dispacting on the events (but not necessarily immediately).

This function use to inherit from Namable, but that makes it too expensive to get its name the Python code. Now it just copies the Namable interface in.

Definition at line 33 of file event.h.

## Member Function Documentation

## ◆ clear_name()

void Event::clear_name | ( |  | ) |
| inline

Resets the Event's name to empty.

Definition at line 25 of file event.I.

## ◆ has_name()

bool Event::has_name | ( |  | ) | const
| inline

Returns true if the Event has a nonempty name set, false if the name is empty.

Definition at line 34 of file event.I.

The documentation for this class was generated from the following files:

- panda/src/event/event.h
- panda/src/event/event.cxx
- panda/src/event/event.I